Index: LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 1864)
+++ LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 1864)
@@ -0,0 +1,345 @@
+! $Id$
+
+SUBROUTINE phyredem (fichnom)
+
+  USE dimphy
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
+  USE fonte_neige_mod,  ONLY : fonte_neige_final
+  USE pbl_surface_mod,  ONLY : pbl_surface_final
+  USE phys_state_var_mod
+  USE iostart
+  USE traclmdz_mod, ONLY : traclmdz_to_restart
+  USE infotrac
+  USE control_mod
+  USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
+  USE indice_sol_mod
+
+  IMPLICIT none
+  !======================================================================
+  ! Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
+  ! Objet: Ecriture de l'etat de redemarrage pour la physique
+  !======================================================================
+  include "netcdf.inc"
+  include "dimsoil.h"
+  include "clesphys.h"
+  include "temps.h"
+  include "thermcell.h"
+  include "compbl.h"
+  !======================================================================
+  CHARACTER*(*) fichnom
+
+  ! les variables globales ecrites dans le fichier restart
+
+  REAL tsoil(klon, nsoilmx, nbsrf)
+  REAL tslab(klon), seaice(klon)
+  REAL qsurf(klon, nbsrf)
+  REAL qsol(klon)
+  REAL snow(klon, nbsrf)
+  REAL evap(klon, nbsrf)
+  real fder(klon)
+  REAL frugs(klon, nbsrf)
+  REAL agesno(klon, nbsrf)
+  REAL run_off_lic_0(klon)
+  REAL trs(klon, nbtr)
+
+  INTEGER nid, nvarid, idim1, idim2, idim3
+  INTEGER ierr
+  INTEGER length
+  PARAMETER (length=100)
+  REAL tab_cntrl(length)
+
+  INTEGER isoil, nsrf
+  CHARACTER (len=7) :: str7
+  CHARACTER (len=2) :: str2
+  INTEGER           :: it, iiq
+
+  !======================================================================
+
+  ! Get variables which will be written to restart file from module 
+  ! pbl_surface_mod
+  CALL pbl_surface_final(qsol, fder, snow, qsurf,  &
+       evap, frugs, agesno, tsoil)
+
+  ! Get a variable calculated in module fonte_neige_mod
+  CALL fonte_neige_final(run_off_lic_0)
+
+  !======================================================================
+
+  CALL open_restartphy(fichnom)
+
+  DO ierr = 1, length
+     tab_cntrl(ierr) = 0.0
+  ENDDO
+  tab_cntrl(1) = dtime
+  tab_cntrl(2) = radpas
+  ! co2_ppm : current value of atmospheric CO2
+  tab_cntrl(3) = co2_ppm
+  tab_cntrl(4) = solaire
+  tab_cntrl(5) = iflag_con
+  tab_cntrl(6) = nbapp_rad
+
+  IF( cycle_diurne ) tab_cntrl( 7 ) = 1.
+  IF(   soil_model ) tab_cntrl( 8 ) = 1.
+  IF(     new_oliq ) tab_cntrl( 9 ) = 1.
+  IF(     ok_orodr ) tab_cntrl(10 ) = 1.
+  IF(     ok_orolf ) tab_cntrl(11 ) = 1.
+
+  tab_cntrl(13) = day_end
+  tab_cntrl(14) = annee_ref
+  tab_cntrl(15) = itau_phy
+
+  ! co2_ppm0 : initial value of atmospheric CO2
+  tab_cntrl(16) = co2_ppm0
+
+  CALL put_var("controle", "Parametres de controle", tab_cntrl)
+
+  CALL put_field("longitude", &
+       "Longitudes de la grille physique", rlon)
+
+  CALL put_field("latitude", "Latitudes de la grille physique", rlat)
+
+  ! PB ajout du masque terre/mer
+
+  CALL put_field("masque", "masque terre mer", zmasq)
+
+  ! BP ajout des fraction de chaque sous-surface
+
+  ! 1. fraction de terre 
+
+  CALL put_field("FTER", "fraction de continent", pctsrf(:, is_ter))
+
+  ! 2. Fraction de glace de terre
+
+  CALL put_field("FLIC", "fraction glace de terre", pctsrf(:, is_lic))
+
+  ! 3. fraction ocean
+
+  CALL put_field("FOCE", "fraction ocean", pctsrf(:, is_oce))
+
+  ! 4. Fraction glace de mer
+
+  CALL put_field("FSIC", "fraction glace mer", pctsrf(:, is_sic))
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("TS"//str2, "Temperature de surface No."//str2, &
+             ftsol(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  DO nsrf = 1, nbsrf
+     DO isoil=1, nsoilmx
+        IF (isoil.LE.99 .AND. nsrf.LE.99) THEN
+           WRITE(str7, '(i2.2, "srf", i2.2)') isoil, nsrf
+           CALL put_field("Tsoil"//str7, "Temperature du sol No."//str7, &
+                tsoil(:, isoil, nsrf))
+        ELSE
+           PRINT*, "Trop de couches"
+           CALL abort
+        ENDIF
+     ENDDO
+  ENDDO
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("QS"//str2, "Humidite de surface No."//str2, &
+             qsurf(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  END DO
+
+  CALL put_field("QSOL", "Eau dans le sol (mm)", qsol)
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("ALBE"//str2, "albedo de surface No."//str2, &
+             falb1(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("ALBLW"//str2, "albedo LW de surface No."//str2, &
+             falb2(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("EVAP"//str2, "Evaporation de surface No."//str2 &
+             , evap(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("SNOW"//str2, "Neige de surface No."//str2, &
+             snow(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  CALL put_field("RADS", "Rayonnement net a la surface", radsol)
+
+  CALL put_field("solsw", "Rayonnement solaire a la surface", solsw)
+
+  CALL put_field("sollw", "Rayonnement IF a la surface", sollw)
+
+  CALL put_field("fder", "Derive de flux", fder)
+
+  CALL put_field("rain_f", "precipitation liquide", rain_fall)
+
+  CALL put_field("snow_f", "precipitation solide", snow_fall)
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("RUG"//str2, "rugosite de surface No."//str2, &
+             frugs(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  DO nsrf = 1, nbsrf
+     IF (nsrf.LE.99) THEN
+        WRITE(str2, '(i2.2)') nsrf
+        CALL put_field("AGESNO"//str2, &
+             "Age de la neige surface No."//str2, &
+             agesno(:, nsrf))
+     ELSE
+        PRINT*, "Trop de sous-mailles"
+        CALL abort
+     ENDIF
+  ENDDO
+
+  CALL put_field("ZMEA", "ZMEA", zmea)
+
+  CALL put_field("ZSTD", "ZSTD", zstd)
+
+  CALL put_field("ZSIG", "ZSIG", zsig)
+
+  CALL put_field("ZGAM", "ZGAM", zgam)
+
+  CALL put_field("ZTHE", "ZTHE", zthe)
+
+  CALL put_field("ZPIC", "ZPIC", zpic)
+
+  CALL put_field("ZVAL", "ZVAL", zval)
+
+  CALL put_field("RUGSREL", "RUGSREL", rugoro)
+
+  CALL put_field("TANCIEN", "TANCIEN", t_ancien)
+
+  CALL put_field("QANCIEN", "QANCIEN", q_ancien)
+
+  CALL put_field("UANCIEN", "", u_ancien)
+
+  CALL put_field("VANCIEN", "", v_ancien)
+
+  CALL put_field("RUGMER", "Longueur de rugosite sur mer", &
+       frugs(:, is_oce))
+
+  CALL put_field("CLWCON", "Eau liquide convective", clwcon)
+
+  CALL put_field("RNEBCON", "Nebulosite convective", rnebcon)
+
+  CALL put_field("RATQS", "Ratqs", ratqs)
+
+  ! run_off_lic_0
+
+  CALL put_field("RUNOFFLIC0", "Runofflic0", run_off_lic_0)
+
+  ! DEB TKE PBL !
+
+  IF (iflag_pbl>1) then
+     DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+           WRITE(str2, '(i2.2)') nsrf
+           CALL put_field("TKE"//str2, "Energ. Cineti. Turb."//str2, &
+                pbl_tke(:, 1:klev+1, nsrf))
+        ELSE
+           PRINT*, "Trop de sous-mailles"
+           CALL abort
+        ENDIF
+     ENDDO
+  ENDIF
+
+  ! FIN TKE PBL !
+  !IM ajout zmax0, f0, sig1, w01
+  !IM wake_deltat, wake_deltaq, wake_s, wake_cstar, wake_pe, wake_fip
+
+  CALL put_field("ZMAX0", "ZMAX0", zmax0)
+
+  CALL put_field("F0", "F0", f0)
+
+  CALL put_field("sig1", "sig1 Emanuel", sig1)
+
+  CALL put_field("w01", "w01 Emanuel", w01)
+
+  ! wake_deltat
+  CALL put_field("WAKE_DELTAT", "WAKE_DELTAT", wake_deltat)
+
+  CALL put_field("WAKE_DELTAQ", "WAKE_DELTAQ", wake_deltaq)
+
+  CALL put_field("WAKE_S", "WAKE_S", wake_s)
+
+  CALL put_field("WAKE_CSTAR", "WAKE_CSTAR", wake_cstar)
+
+  CALL put_field("WAKE_PE", "WAKE_PE", wake_pe)
+
+  CALL put_field("WAKE_FIP", "WAKE_FIP", wake_fip)
+
+  ! thermiques
+
+  CALL put_field("FM_THERM", "FM_THERM", fm_therm)
+
+  CALL put_field("ENTR_THERM", "ENTR_THERM", entr_therm)
+
+  CALL put_field("DETR_THERM", "DETR_THERM", detr_therm)
+
+  ! trs from traclmdz_mod
+  IF (type_trac == 'lmdz') THEN
+     CALL traclmdz_to_restart(trs)
+     DO it=1, nbtr
+        iiq=niadv(it+2)
+        CALL put_field("trs_"//tname(iiq), "", trs(:, it))
+     END DO
+     IF (carbon_cycle_cpl) THEN
+        IF (.NOT. ALLOCATED(co2_send)) THEN
+           ! This is the case of create_etat0_limit, ce0l
+           ALLOCATE(co2_send(klon))
+           co2_send(:) = co2_ppm0
+        END IF
+        CALL put_field("co2_send", "co2_ppm for coupling", co2_send)
+     END IF
+  END IF
+
+  CALL close_restartphy
+  !$OMP BARRIER
+
+END SUBROUTINE phyredem
Index: LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 1864)
@@ -3,5 +3,4 @@
 !
       MODULE phys_local_var_mod
-
 ! Variables locales pour effectuer les appels en serie
 !======================================================================
@@ -187,4 +186,82 @@
 !$OMP THREADPRIVATE(topswcf_aerop, solswcf_aerop)
 
+
+!Ajout de celles nécessaires au phys_output_write_mod
+      REAL, SAVE, ALLOCATABLE :: slp(:)
+!$OMP THREADPRIVATE(slp)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: sens, flwp, fiwp 
+!$OMP THREADPRIVATE(sens, flwp, fiwp)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: ale_wake, alp_wake, bils
+!$OMP THREADPRIVATE(ale_wake, alp_wake, bils)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: cdragm, cdragh
+!$OMP THREADPRIVATE(cdragm, cdragh)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: cldh, cldl, cldm, cldq, cldt, qsat2m, qsol
+!$OMP THREADPRIVATE(cldh, cldl, cldm, cldq, cldt, qsat2m, qsol)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: dthmin, evap, fder, plcl, plfc, prw
+!$OMP THREADPRIVATE(dthmin, evap, fder, plcl, plfc, prw)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zustar, zu10m, zv10m, rh2m
+!$OMP THREADPRIVATE(zustar, zu10m, zv10m, rh2m)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: s_lcl, s_pblh, s_pblt, s_therm
+!$OMP THREADPRIVATE(s_lcl, s_pblh, s_pblt, s_therm)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: slab_wfbils
+!$OMP THREADPRIVATE(slab_wfbils)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: tpot, tpote, ue, uq, ve, vq, zxffonte
+!$OMP THREADPRIVATE(tpot, tpote, ue, uq, ve, vq, zxffonte)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfqcalving
+!$OMP THREADPRIVATE(zxfqcalving)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfluxlat, zxrugs, zxtsol, snow_lsc, zxfqfonte
+!$OMP THREADPRIVATE(zxfluxlat, zxrugs, zxtsol, snow_lsc, zxfqfonte)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxqsurf, rain_lsc
+!$OMP THREADPRIVATE(zxqsurf, rain_lsc)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: wake_h, wbeff, zmax_th, zq2m, zt2m
+!$OMP THREADPRIVATE(wake_h, wbeff, zmax_th, zq2m, zt2m)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: weak_inversion
+!$OMP THREADPRIVATE(weak_inversion)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: ale_bl_stat,alp_bl_conv,alp_bl_det
+!$OMP THREADPRIVATE(ale_bl_stat,alp_bl_conv,alp_bl_det)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: alp_bl_fluct_m,alp_bl_fluct_tke
+!$OMP THREADPRIVATE(alp_bl_fluct_m,alp_bl_fluct_tke)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: alp_bl_stat, n2, s2
+!$OMP THREADPRIVATE(alp_bl_stat, n2, s2)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: proba_notrig, random_notrig
+!$OMP THREADPRIVATE(proba_notrig, random_notrig)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: fsolsw, wfbils, wfbilo
+!$OMP THREADPRIVATE(fsolsw, wfbils, wfbilo)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: t2m, fevap, fluxlat, fsollw,evap_pot
+!$OMP THREADPRIVATE(t2m, fevap, fluxlat, fsollw,evap_pot)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: dnwd, dnwd0, upwd, omega
+!$OMP THREADPRIVATE(dnwd, dnwd0, upwd, omega)
+!      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: coefh, coefm, lambda_th
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: lambda_th
+!$OMP THREADPRIVATE(lambda_th)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: cldemi, cldfra, cldtau, fiwc, fl, re, flwc
+!$OMP THREADPRIVATE(cldemi, cldfra, cldtau, fiwc, fl, re, flwc)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: ref_liq, ref_ice, theta, zphi
+!$OMP THREADPRIVATE(ref_liq, ref_ice, theta, zphi)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: wake_omg, zx_rh
+!$OMP THREADPRIVATE(wake_omg, zx_rh)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: frugs, agesno
+!$OMP THREADPRIVATE(frugs, agesno)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: pmflxr, pmflxs, prfl, psfl, fraca
+!$OMP THREADPRIVATE(pmflxr, pmflxs, prfl, psfl, fraca)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: Vprecip, zw2
+!$OMP THREADPRIVATE(Vprecip, zw2)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: pmfd, pmfu
+!$OMP THREADPRIVATE(pmfd, pmfu)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:,:) :: fluxt, fluxu, fluxv
+!$OMP THREADPRIVATE(fluxt, fluxu, fluxv)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:,:) :: uwriteSTD, vwriteSTD, wwriteSTD
+!$OMP THREADPRIVATE(uwriteSTD, vwriteSTD, wwriteSTD)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:,:) :: phiwriteSTD, qwriteSTD, twriteSTD, rhwriteSTD
+!$OMP THREADPRIVATE(phiwriteSTD, qwriteSTD, twriteSTD, rhwriteSTD)
+
+! ug et d'autres encore:
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: wdtrainA, wdtrainM
+!$OMP THREADPRIVATE(wdtrainA, wdtrainM)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: beta_prec
+!$OMP THREADPRIVATE(beta_prec)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: rneb
+!$OMP THREADPRIVATE(rneb)
+
 CONTAINS
 
@@ -195,4 +272,6 @@
 USE aero_mod
 USE indice_sol_mod
+USE phys_output_var_mod
+USE phys_state_var_mod
 
 IMPLICIT NONE
@@ -279,4 +358,60 @@
       ALLOCATE(topswcf_aerop(klon,naero_grp), solswcf_aerop(klon,naero_grp))
 
+! FH Ajout de celles nécessaires au phys_output_write_mod
+
+      ALLOCATE(slp(klon))
+      ALLOCATE(ale_wake(klon), alp_wake(klon), bils(klon))
+      ALLOCATE(cdragm(klon), cdragh(klon), cldh(klon), cldl(klon))
+      ALLOCATE(cldm(klon), cldq(klon), cldt(klon), qsat2m(klon), qsol(klon))
+      ALLOCATE(dthmin(klon), evap(klon), fder(klon), plcl(klon), plfc(klon))
+      ALLOCATE(prw(klon), zustar(klon), zu10m(klon), zv10m(klon), rh2m(klon))
+      ALLOCATE(s_lcl(klon))
+      ALLOCATE(s_pblh(klon), s_pblt(klon), s_therm(klon))
+      ALLOCATE(slab_wfbils(klon), tpot(klon), tpote(klon), ue(klon))
+      ALLOCATE(uq(klon), ve(klon), vq(klon), zxffonte(klon))
+      ALLOCATE(zxfqcalving(klon), zxfluxlat(klon), zxrugs(klon))
+      ALLOCATE(zxtsol(klon), snow_lsc(klon), zxfqfonte(klon), zxqsurf(klon))
+      ALLOCATE(rain_lsc(klon), wake_h(klon), wbeff(klon), zmax_th(klon))
+      ALLOCATE(zq2m(klon), zt2m(klon), weak_inversion(klon))
+      ALLOCATE(sens(klon), flwp(klon), fiwp(klon))
+      ALLOCATE(ale_bl_stat(klon), alp_bl_conv(klon), alp_bl_det(klon))
+      ALLOCATE(alp_bl_fluct_m(klon), alp_bl_fluct_tke(klon))
+      ALLOCATE(alp_bl_stat(klon), n2(klon), s2(klon))
+      ALLOCATE(proba_notrig(klon), random_notrig(klon))
+
+      ALLOCATE(dnwd(klon, klev), dnwd0(klon, klev))
+!      ALLOCATE(upwd(klon, klev), omega(klon, klev), coefh(klon, klev))
+      ALLOCATE(upwd(klon, klev), omega(klon, klev))
+!      ALLOCATE(coefm(klon, klev), lambda_th(klon, klev), cldemi(klon, klev))
+      ALLOCATE(lambda_th(klon, klev), cldemi(klon, klev))
+      ALLOCATE(cldfra(klon, klev), cldtau(klon, klev), fiwc(klon, klev))
+      ALLOCATE(fl(klon, klev), re(klon, klev), flwc(klon, klev))
+      ALLOCATE(ref_liq(klon, klev), ref_ice(klon, klev), theta(klon, klev))
+      ALLOCATE(zphi(klon, klev), wake_omg(klon, klev), zx_rh(klon, klev))
+      ALLOCATE(pmfd(klon, klev), pmfu(klon, klev))
+
+      ALLOCATE(t2m(klon, nbsrf), fevap(klon, nbsrf), fluxlat(klon, nbsrf))
+      ALLOCATE(frugs(klon, nbsrf), agesno(klon, nbsrf), fsollw(klon, nbsrf))
+      ALLOCATE(fsolsw(klon, nbsrf), wfbils(klon, nbsrf), wfbilo(klon, nbsrf))
+      ALLOCATE(evap_pot(klon, nbsrf))
+
+      ALLOCATE(pmflxr(klon, klev+1), pmflxs(klon, klev+1), prfl(klon, klev+1))
+      ALLOCATE(psfl(klon, klev+1), fraca(klon, klev+1), Vprecip(klon, klev+1))
+      ALLOCATE(zw2(klon, klev+1))
+
+      ALLOCATE(fluxu(klon, klev, nbsrf), fluxv(klon, klev, nbsrf))
+      ALLOCATE(fluxt(klon, klev, nbsrf))
+
+      ALLOCATE(uwriteSTD(klon,nlevSTD,nfiles), vwriteSTD(klon,nlevSTD,nfiles))
+      ALLOCATE(wwriteSTD(klon,nlevSTD,nfiles), phiwriteSTD(klon,nlevSTD,nfiles))
+      ALLOCATE(qwriteSTD(klon,nlevSTD,nfiles), twriteSTD(klon,nlevSTD,nfiles))
+      ALLOCATE(rhwriteSTD(klon,nlevSTD,nfiles))
+
+! ug et d'autres encore:
+      ALLOCATE(wdtrainA(klon,klev),wdtrainM(klon,klev))
+      ALLOCATE(beta_prec(klon,klev))
+      ALLOCATE(rneb(klon,klev))
+
+
 END SUBROUTINE phys_local_var_init
 
@@ -368,4 +503,56 @@
       deallocate(topswcf_aerop, solswcf_aerop)
 
+
+! FH Ajout de celles nécessaires au phys_output_write_mod
+      DEALLOCATE(slp)
+      DEALLOCATE(ale_wake, alp_wake, bils)
+      DEALLOCATE(cdragm, cdragh, cldh, cldl)
+      DEALLOCATE(cldm, cldq, cldt, qsat2m, qsol)
+      DEALLOCATE(dthmin, evap, fder, plcl, plfc)
+      DEALLOCATE(prw, zustar, zu10m, zv10m, rh2m, s_lcl)
+      DEALLOCATE(s_pblh, s_pblt, s_therm)
+      DEALLOCATE(slab_wfbils, tpot, tpote, ue)
+      DEALLOCATE(uq, ve, vq, zxffonte)
+      DEALLOCATE(zxfqcalving, zxfluxlat, zxrugs)
+      DEALLOCATE(zxtsol, snow_lsc, zxfqfonte, zxqsurf)
+      DEALLOCATE(rain_lsc, wake_h, wbeff, zmax_th)
+      DEALLOCATE(zq2m, zt2m, weak_inversion)
+      DEALLOCATE(sens, flwp, fiwp)
+      DEALLOCATE(ale_bl_stat,alp_bl_conv,alp_bl_det)
+      DEALLOCATE(alp_bl_fluct_m,alp_bl_fluct_tke)
+      DEALLOCATE(alp_bl_stat, n2, s2)
+      DEALLOCATE(proba_notrig, random_notrig)
+
+      DEALLOCATE(dnwd, dnwd0)
+!      DEALLOCATE(upwd, omega, coefh)
+      DEALLOCATE(upwd, omega)
+!      DEALLOCATE(coefm, lambda_th, cldemi)
+      DEALLOCATE(lambda_th, cldemi)
+      DEALLOCATE(cldfra, cldtau, fiwc)
+      DEALLOCATE(fl, re, flwc)
+      DEALLOCATE(ref_liq, ref_ice, theta)
+      DEALLOCATE(zphi, wake_omg, zx_rh)
+      DEALLOCATE(pmfd, pmfu)
+
+      DEALLOCATE(t2m, fevap, fluxlat)
+      DEALLOCATE(frugs, agesno, fsollw, evap_pot)
+      DEALLOCATE(fsolsw, wfbils, wfbilo)
+
+      DEALLOCATE(pmflxr, pmflxs, prfl)
+      DEALLOCATE(psfl, fraca, Vprecip)
+      DEALLOCATE(zw2)
+
+      DEALLOCATE(fluxu, fluxv)
+      DEALLOCATE(fluxt)
+
+      DEALLOCATE(uwriteSTD, vwriteSTD)
+      DEALLOCATE(wwriteSTD, phiwriteSTD)
+      DEALLOCATE(qwriteSTD, twriteSTD, rhwriteSTD)
+
+! ug et d'autres encore:
+      DEALLOCATE(wdtrainA, wdtrainM)
+      DEALLOCATE(beta_prec)
+      DEALLOCATE(rneb)
+
 END SUBROUTINE phys_local_var_end
 
